<cfcomponent name="ListDataSample">

	<cffunction name="loadSomething" access="remote" output="false" returntype="Array">

		<cfset var uPerson = "">
		<cfset var ret = ArrayNew(1)>
		
		<cfif IsDefined("Session.PersonArray")>
			<cfset ret = Session.PersonArray>
		<cfelse>
			
			<cfloop index="i" from="1" to="100">
				
				<cfset uPerson = CreateObject("component",
									"flex_samples.RemoteObject.RemoteObjectSample.UPerson")>
	
				<cfset uPerson.FirstName = "John " & RandRange(0, 100)>
				<cfset uPerson.LastName = "Smith " & RandRange(0, 100)>
				<cfset uPerson.Age = RandRange(0, 100)>
				
				<cfset uPerson.uKey = i>
				
				<cfset ArrayAppend(ret, uPerson)>
				
			</cfloop>
			
			<cfset Session.PersonArray = ret>
		
		</cfif>
		
		<cfreturn ret>
	</cffunction>
	

	<cffunction name="sendSomething" access="remote" output="false" returntype="Numeric">
		<cfargument name="uPerson" required="true" type="flex_samples.RemoteObject.RemoteObjectSample.UPerson">
		
		<cfset ret = arguments.uPerson.uKey>
		
		<cfif not ret eq -1>
			<cfif not IsDefined("Session.PersonArray")>
				<cfset loadSomething()>
			</cfif>
			
			<cftry>
				<cfset Session.PersonArray[arguments.uPerson.uKey] = arguments.uPerson>
				<cfcatch type="any">
					<cfset ret = -1>
					<cfrethrow>
				</cfcatch>
			</cftry>
		</cfif>
		
		<cfreturn ret>
	</cffunction>

</cfcomponent>